/* ********************************************************
    make_rg.cpp

    Author = Hideyuki Harada
    Nihon Univ. Tani Research Group


    Create random graph for LEDA by size of V and edege density
    designed for "g++ 3.3.3" with "LEDA 4.5"
   ******************************************************** */


#include<LEDA/graph.h>
#include<iostream.h>
#include<fstream.h>
#include<string.h>
#include<stdio.h>
#include<LEDA/list.h>

#define P_VERSION "make_rg 0.01"

using namespace leda;

int file_exist(char file_name[]);

//*************************************************


int main(int argc, char *argv[]){

  double density;
  int num_v, num_e;
  node u, v;
  int i, flag;
  graph G;
  char out_file[100];
  edge e;

  /*
  if(argc != 3){
    cout << "usage: make_rg [num_vertex] [edge_density]" << endl;
    exit(1);
  }
  */
  srand(time(NULL));  

  cout << "number of vertex:";
  cin >> num_v;

  cout << "density:";
  cin >> density;


  for(i=0; i<num_v; i++){
    v=G.new_node();
  }
  num_e = (num_v*(num_v-1))*density;
  G.make_undirected();


  i = 1;
  do{
    flag = 0;
    sprintf(out_file, "rg_%d_%g_%d.gw", num_v, density, i);
    if( file_exist(out_file)==1 ){
      flag = 1;
      i++;
    }
  }while(flag == 1);


  for(i=0 ; i<num_e ; i++){
    u = G.choose_node();
    v = G.choose_node();
    if( u!=v && (G.adj_nodes(u)).search(v) == NULL){
      e = G.new_edge(u, v);
    }else{
      i--;
    }
  }


  G.write(out_file);
  cout << "New ramdom graph is saved as \"" << out_file << "\"" << endl;

  return 0;

}


int file_exist(char file_name[]){
  FILE *fp1;

  if( (fp1 = fopen(file_name, "r"))==NULL ){
    return(0);
  }

  fclose(fp1);
  return(1);

}


  /*
  ofstream fout;
  fout.open(argv[1]+ofile, ios::app);
  fout.close();
  */


